<template>
	<table>
		<thead>
			<tr>
				<th>Name</th>
				<th class="date">Date</th>
				<th>Start</th>
				<th>End</th>
				<th>Duration</th>
				<th></th>
			</tr>
		</thead>
		<tbody>
			<tr v-if="loading">
				<td class="loading" colspan="6">Data se načítají</td>
			</tr>
			<tr v-else v-for="item of visibleItems" :key="item.id">
				<TimesheetDetailsRow
					:model-value="item"
					:team-id="props.teamId"
					@update:model-value="updateItem"
					@delete="deleteItem"
				/>
			</tr>
		</tbody>
	</table>
	<div class="toolbar">
		<el-button type="success" @click="save">Uložit</el-button>
		<el-button @click="newItem" type="primary">Přidat</el-button>
	</div>
</template>

<script lang="ts" setup>
import { computed, onMounted, onUnmounted, ref, watch } from "vue";
import { ClickUpdateTimesheetItem, TE } from "../../lib/types";
import { dateAddDuration, dateEndOfDay, dateStartOfDay, dateTimeCompare, durationFromDate, DurationTime, pipe } from "../../lib/utils";
import { clickupClient } from "../ts/apis";
import { TimesheetDayItem, TimesheetDetailItem, TimesheetItem } from "../ts/types";
import { apiResolveOrAlert, getUserInfo, uiSingleAlert } from "../ts/utils";
import { loadClickTimesheetDetailItems } from "./timesheet";
import { ElButton } from "element-plus";
import TimesheetDetailsRow from "./TimesheetDetailsRow.vue";
import { ApiError } from "../../lib/Errors";

const props = defineProps<{
	day: Date;
	teamId: number;
}>();

const items = ref<TimesheetDetailItem[]>([]);
const loading = ref(false);
const newItemIndex = ref(0);

const visibleItems = computed(() => items.value.filter(x => x.state !== "delete"));

onMounted(() => {
	loadItems(props.day);
});

onUnmounted(() => {
	items.value = [];
	newItemIndex.value = 0;
})

watch(() => props.day, (day) => {
	loadItems(day);
});

async function loadItems(day: Date) {
	loading.value = true;
	const start = dateStartOfDay(day);
	const result = await apiResolveOrAlert(loadClickTimesheetDetailItems({
		start,
		end: dateEndOfDay(day),
		teamId: props.teamId
	}), []);

	result.sort((a, b) => dateTimeCompare(a.start, b.start));

	loading.value = false;

	items.value = result.map(x => ({
		id: x.id,
		taskId: x.task?.id || 'ID_Unknown',
		name: x.task?.name || 'Unknown',
		date: start,
		start: durationFromDate(x.start),
		end: durationFromDate(x.end),
		duration: x.duration,
		state: "idle",
		userId: x.user.id,
	}));
}

async function newItem() {
	const index = newItemIndex.value + 1;
	const userId = await getUserInfo("Click")().then(x => {
		if (x?.kind === "Click") {
			return x.id;
		}
		return undefined;
	});

	if (userId === undefined) {
		uiSingleAlert("User ID is not defined.");
		return;
	}

	items.value = [
		...items.value,
		{
			id: 'newItem_' + index,
			date: props.day,
			taskId: undefined,
			name: '',
			duration: DurationTime.zero(),
			start: DurationTime.zero(),
			end: DurationTime.zero(),
			state: "add",
			userId,
		}
	];
	newItemIndex.value = index;
}

function deleteItem(item: TimesheetDetailItem) {
	items.value = items.value.map(x => {
		if (x.id === item.id) {
			return {
				...x,
				state: "delete"
			};
		}

		return x;
	});
}

function updateItem(item: TimesheetDetailItem) {
	items.value = items.value.reduce<TimesheetDetailItem[]>((s, c) => {
		if (c.id === item.id) {
			console.log('update', item.state);
			s.push({
				...item,
				state: item.state === "idle" ? "update" : item.state,
			});
		} else {
			s.push(c);
		}
		return s;
	}, []);
	console.log('update');
}

function save() {
	const update = clickupClient.updateTimesheets({
		teamId: props.teamId,
		items: items.value.filter(x => x.state !== "idle" && x.taskId !== undefined).map<ClickUpdateTimesheetItem>(x => {
			const start = dateAddDuration(x.date, x.start);
			const end = dateAddDuration(x.date, x.end);

			switch (x.state) {
				case "idle":
				case "update":
					return {
						type: "update",
						id: x.id,
						taskId: x.taskId || '',
						start,
						end,
						description: '',
						userId: x.userId,
						billable: true,
					};

				case "delete":
					return {
						type: "delete",
						id: x.id,
					};

				case "add":
					return {
						type: "add",
						id: x.id,
						taskId: x.taskId || '',
						start,
						end,
						description: '',
						userId: x.userId,
						billable: true,
					}
			}
		})
	});

	apiResolveOrAlert(pipe(
		update,
		TE.map((x) => {
			if (x.length > 0) {
				loadItems(props.day);
			}
		})
	), null);
}
</script>

<style lang="scss" scoped>
.el-date-editor {
	width: 140px !important;
}

table {
	width: 100%;
}

.loading {
	color: blue;
	font-size: 16px;
	text-align: center;
}

.toolbar {
	display: flex;
	justify-content: right;
}
</style>
